#pragma once

#include "DataSpec/DNACommon/Tweaks/ITweakGui.hpp"

namespace DataSpec::DNAMP1 {
struct CTweakGui final : ITweakGui {
  AT_DECL_DNA_YAML
  Value<bool> x4_;
  Value<float> x8_mapAlphaInterp;
  Value<float> xc_pauseBlurFactor;
  Value<float> x10_radarXYRadius;
  Value<float> x14_;
  Value<float> x18_;
  Value<float> x1c_;
  Value<float> x20_;
  Value<float> x24_radarZRadius;
  Value<float> x28_radarZCloseRadius;
  atUint32 x2c_ = 0;
  Value<float> x30_;
  Value<float> x34_energyBarFilledSpeed;
  Value<float> x38_energyBarShadowSpeed;
  Value<float> x3c_energyBarDrainDelay;
  Value<bool> x40_energyBarAlwaysResetDelay;
  Value<float> x44_hudDamagePracticalsGainConstant;
  Value<float> x48_hudDamagePracticalsGainLinear;
  Value<float> x4c_hudDamagePracticalsInitConstant;
  Value<float> x50_hudDamagePracticalsInitLinear;
  Value<float> x54_hudDamageLightSpotAngle;
  Value<float> x58_damageLightAngleC;
  Value<float> x5c_damageLightAngleL;
  Value<float> x60_damageLightAngleQ;
  Value<atVec3f> x64_damageLightPreTranslate;
  Value<atVec3f> x70_damageLightCenterTranslate;
  Value<float> x7c_damageLightXfXAngle;
  Value<float> x80_damageLightXfZAngle;
  Value<float> x84_hudDecoShakeTranslateVelConstant;
  Value<float> x88_hudDecoShakeTranslateVelLinear;
  Value<float> x8c_maxDecoDamageShakeTranslate;
  Value<float> x90_decoDamageShakeDeceleration;
  Value<float> x94_decoShakeGainConstant;
  Value<float> x98_decoShakeGainLinear;
  Value<float> x9c_decoShakeInitConstant;
  Value<float> xa0_decoShakeInitLinear;
  Value<float> xa4_maxDecoDamageShakeRotate;
  Value<atUint32> xa8_hudCamFovTweak;
  Value<atUint32> xac_hudCamYTweak;
  Value<atUint32> xb0_hudCamZTweak;
  Value<float> xb4_;
  Value<float> xb8_;
  Value<float> xbc_;
  Value<float> xc0_beamVisorMenuAnimTime;
  Value<float> xc4_visorBeamMenuItemActiveScale;
  Value<float> xc8_visorBeamMenuItemInactiveScale;
  Value<float> xcc_visorBeamMenuItemTranslate;
  Value<float> xd0_;
  Value<atUint32> xd4_;
  Value<float> xd8_;
  Value<float> xdc_;
  Value<float> xe0_;
  Value<float> xe4_threatRange;
  Value<float> xe8_radarScopeCoordRadius;
  Value<float> xec_radarPlayerPaintRadius;
  Value<float> xf0_radarEnemyPaintRadius;
  Value<float> xf4_missileArrowVisTime;
  Value<EHudVisMode> xf8_hudVisMode;
  Value<EHelmetVisMode> xfc_helmetVisMode;
  Value<atUint32> x100_enableAutoMapper;
  Value<atUint32> x104_;
  Value<atUint32> x108_enableTargetingManager;
  Value<atUint32> x10c_enablePlayerVisor;
  Value<float> x110_threatWarningFraction;
  Value<float> x114_missileWarningFraction;
  Value<float> x118_freeLookFadeTime;
  Value<float> x11c_;
  Value<float> x120_;
  Value<float> x124_;
  Value<float> x128_;
  Value<float> x12c_freeLookSfxPitchScale;
  Value<bool> x130_noAbsoluteFreeLookSfxPitch;
  Value<float> x134_;
  Value<float> x138_;
  Value<atUint32> x13c_faceReflectionOrthoWidth;
  Value<atUint32> x140_faceReflectionOrthoHeight;
  Value<atUint32> x144_faceReflectionDistance;
  Value<atUint32> x148_faceReflectionHeight;
  Value<atUint32> x14c_faceReflectionAspect;
  String<-1> x150_;
  String<-1> x160_;
  String<-1> x170_;
  String<-1> x180_;
  String<-1> x190_;
  Value<float> x1a0_missileWarningPulseTime;
  Value<float> x1a4_explosionLightFalloffMultConstant;
  Value<float> x1a8_explosionLightFalloffMultLinear;
  Value<float> x1ac_explosionLightFalloffMultQuadratic;
  Value<float> x1b0_;
  Value<float> x1b4_hudDamagePeakFactor;
  Value<float> x1b8_hudDamageFilterGainConstant;
  Value<float> x1bc_hudDamageFilterGainLinear;
  Value<float> x1c0_hudDamageFilterInitConstant;
  Value<float> x1c4_hudDamageFilterInitLinear;
  Value<float> x1c8_energyDrainModPeriod;
  Value<bool> x1cc_energyDrainSinusoidalPulse;
  Value<bool> x1cd_energyDrainFilterAdditive;
  Value<float> x1d0_hudDamagePulseDuration;
  Value<float> x1d4_hudDamageColorGain;
  Value<float> x1d8_hudDecoShakeTranslateGain;
  Value<float> x1dc_hudLagOffsetScale;
  Value<float> x1e0_;
  Value<float> x1e4_;
  Value<float> x1e8_;
  Value<float> x1ec_;
  Value<float> x1f0_;
  Value<float> x1f4_;
  Value<float> x1f8_;
  Value<float> x1fc_;
  zeus::CColor x200_;
  float x204_xrayBlurScaleLinear = 0.0014f;
  float x208_xrayBlurScaleQuadratic = 0.0000525f;
  Value<float> x20c_;
  Value<float> x210_scanSidesAngle;
  Value<float> x214_scanSidesXScale;
  Value<float> x218_scanSidesPositionEnd;
  Value<float> x21c_;
  Value<float> x220_scanSidesDuration;
  Value<float> x224_scanSidesStartTime;
  float x228_scanSidesEndTime;
  Value<float> x22c_scanDataDotRadius;
  Value<float> x230_scanDataDotPosRandMag;
  Value<float> x234_scanDataDotSeekDurationMin;
  Value<float> x238_scanDataDotSeekDurationMax;
  Value<float> x23c_scanDataDotHoldDurationMin;
  Value<float> x240_scanDataDotHoldDurationMax;
  Value<float> x244_scanAppearanceDuration;
  Value<float> x248_scanPaneFlashFactor;
  Value<float> x24c_scanPaneFadeInTime;
  Value<float> x250_scanPaneFadeOutTime;
  Value<float> x254_ballViewportYReduction;
  Value<float> x258_scanWindowIdleW;
  Value<float> x25c_scanWindowIdleH;
  Value<float> x260_scanWindowActiveW;
  Value<float> x264_scanWindowActiveH;
  Value<float> x268_scanWindowMagnification;
  Value<float> x26c_scanWindowScanningAspect;
  Value<float> x270_scanSidesPositionStart;
  Value<bool> x274_showAutomapperInMorphball;
  bool x275_latchArticleText = true;
  Value<float> x278_wtMgrCharsPerSfx;
  Value<atUint32> x27c_xrayFogMode;
  Value<float> x280_xrayFogNearZ;
  Value<float> x284_xrayFogFarZ;
  DNAColor x288_xrayFogColor;
  Value<float> x28c_thermalVisorLevel;
  DNAColor x290_thermalVisorColor;
  DNAColor x294_hudLightAddPerVisor[4];
  DNAColor x2a4_hudLightMultiplyPerVisor[4];
  DNAColor x2b4_hudReflectivityLightColor;
  Value<float> x2b8_hudLightAttMulConstant;
  Value<float> x2bc_hudLightAttMulLinear;
  Value<float> x2c0_hudLightAttMulQuadratic;
  Value<atUint32> m_scanSpeedsCount;
  Vector<float, AT_DNA_COUNT(m_scanSpeedsCount)> x2c4_scanSpeeds;
  String<-1> x2d0_creditsTable;
  String<-1> x2e0_creditsFont;
  String<-1> x2f0_japaneseCreditsFont;
  DNAColor x300_;
  DNAColor x304_;
  Value<float> x308_;
  Value<float> x30c_;
  Value<float> x310_;
  String<-1> x314_;
  String<-1> x324_;
  String<-1> x334_;
  DNAColor x344_;
  DNAColor x348_;
  DNAColor x34c_;
  DNAColor x350_;
  DNAColor x354_;
  DNAColor x358_;
  Value<float> x35c_;
  Value<float> x360_;
  Value<float> x364_;

  CTweakGui() = default;
};

} // namespace DataSpec::DNAMP1
