#pragma once

#include "DataSpec/DNACommon/Tweaks/ITweakPlayer.hpp"

namespace hecl {
class CVar;
}

namespace DataSpec::DNAMP1 {

struct CTweakPlayer final : ITweakPlayer {
  AT_DECL_EXPLICIT_DNA_YAML
  Value<float> x4_maxTranslationalAcceleration[8];
  Value<float> x24_maxRotationalAcceleration[8];
  Value<float> x44_translationFriction[8];
  Value<float> x64_rotationFriction[8];
  Value<float> x84_rotationMaxSpeed[8];
  Value<float> xa4_translationMaxSpeed[8];
  Value<float> xc4_normalGravAccel;
  Value<float> xc8_fluidGravAccel;
  Value<float> xcc_verticalJumpAccel;
  Value<float> xd0_horizontalJumpAccel;
  Value<float> xd4_verticalDoubleJumpAccel;
  Value<float> xd8_horizontalDoubleJumpAccel;
  Value<float> xdc_waterJumpFactor;
  Value<float> xe0_waterBallJumpFactor;
  Value<float> xe4_lavaJumpFactor;
  Value<float> xe8_lavaBallJumpFactor;
  Value<float> xec_phazonJumpFactor;
  Value<float> xf0_phazonBallJumpFactor;
  Value<float> xf4_allowedJumpTime;
  Value<float> xf8_allowedDoubleJumpTime;
  Value<float> xfc_minDoubleJumpWindow;
  Value<float> x100_maxDoubleJumpWindow;
  Value<float> x104_;
  Value<float> x108_minJumpTime;
  Value<float> x10c_minDoubleJumpTime;
  Value<float> x110_allowedLedgeTime;
  Value<float> x114_doubleJumpImpulse;
  Value<float> x118_backwardsForceMultiplier;
  Value<float> x11c_bombJumpRadius;
  Value<float> x120_bombJumpHeight;
  Value<float> x124_eyeOffset;
  Value<float> x128_turnSpeedMultiplier;
  Value<float> x12c_freeLookTurnSpeedMultiplier;
  Value<float> x130_horizontalFreeLookAngleVel;
  Value<float> x134_verticalFreeLookAngleVel;
  Value<float> x138_freeLookSpeed;
  Value<float> x13c_freeLookSnapSpeed;
  Value<float> x140_;
  Value<float> x144_freeLookCenteredThresholdAngle;
  Value<float> x148_freeLookCenteredTime;
  Value<float> x14c_freeLookDampenFactor;
  Value<float> x150_leftDiv;
  Value<float> x154_rightDiv;
  Value<float> x158_orbitMinDistance[3];
  Value<float> x164_orbitNormalDistance[3];
  Value<float> x170_orbitMaxDistance[3];
  Value<float> x17c_;
  Value<float> x180_orbitModeTimer;
  Value<float> x184_orbitCameraSpeed;
  Value<float> x188_orbitUpperAngle;
  Value<float> x18c_orbitLowerAngle;
  Value<float> x190_orbitHorizAngle;
  Value<float> x194_;
  Value<float> x198_;
  Value<float> x19c_orbitMaxTargetDistance;
  Value<float> x1a0_orbitMaxLockDistance;
  Value<float> x1a4_orbitDistanceThreshold;
  Value<atUint32> x1a8_orbitScreenBoxHalfExtentX[2];
  Value<atUint32> x1b0_orbitScreenBoxHalfExtentY[2];
  Value<atUint32> x1b8_orbitScreenBoxCenterX[2];
  Value<atUint32> x1c0_orbitScreenBoxCenterY[2];
  Value<atUint32> x1c8_orbitZoneIdealX[2];
  Value<atUint32> x1d0_orbitZoneIdealY[2];
  Value<float> x1d8_orbitNearX;
  Value<float> x1dc_orbitNearZ;
  Value<float> x1e0_;
  Value<float> x1e4_;
  Value<float> x1e8_orbitFixedOffsetZDiff;
  Value<float> x1ec_orbitZRange;
  Value<float> x1f0_;
  Value<float> x1f4_;
  Value<float> x1f8_;
  Value<float> x1fc_orbitPreventionTime;
  Value<bool> x200_24_dashEnabled : 1;
  Value<bool> x200_25_dashOnButtonRelease : 1;
  Value<float> x204_dashButtonHoldCancelTime;
  Value<float> x208_dashStrafeInputThreshold;
  Value<float> x20c_sidewaysDoubleJumpImpulse;
  Value<float> x210_sidewaysVerticalDoubleJumpAccel;
  Value<float> x214_sidewaysHorizontalDoubleJumpAccel;
  Value<float> x218_scanningRange;
  Value<bool> x21c_24_scanRetention : 1;
  Value<bool> x21c_25_scanFreezesGame : 1;
  Value<bool> x21c_26_orbitWhileScanning : 1;
  Value<float> x220_scanMaxTargetDistance;
  Value<float> x224_scanMaxLockDistance;
  Value<bool> x228_24_freelookTurnsPlayer : 1;
  Value<bool> x228_25_ : 1;
  Value<bool> x228_26_ : 1;
  Value<bool> x228_27_moveDuringFreeLook : 1;
  Value<bool> x228_28_holdButtonsForFreeLook : 1;
  Value<bool> x228_29_twoButtonsForFreeLook : 1;
  Value<bool> x228_30_ : 1;
  Value<bool> x228_31_ : 1;
  Value<bool> x229_24_ : 1;
  Value<bool> x229_25_aimWhenOrbitingPoint : 1;
  Value<bool> x229_26_stayInFreeLookWhileFiring : 1;
  Value<bool> x229_27_ : 1;
  Value<bool> x229_28_ : 1;
  Value<bool> x229_29_orbitFixedOffset : 1;
  Value<bool> x229_30_gunButtonTogglesHolster : 1;
  Value<bool> x229_31_gunNotFiringHolstersGun : 1;
  Value<bool> x22a_24_fallingDoubleJump : 1;
  Value<bool> x22a_25_impulseDoubleJump : 1;
  Value<bool> x22a_26_firingCancelsCameraPitch : 1;
  Value<bool> x22a_27_assistedAimingIgnoreHorizontal : 1;
  Value<bool> x22a_28_assistedAimingIgnoreVertical : 1;
  Value<float> x22c_;
  Value<float> x230_;
  Value<float> x234_aimMaxDistance;
  Value<float> x238_;
  Value<float> x23c_;
  Value<float> x240_;
  Value<float> x244_;
  Value<float> x248_;
  Value<float> x24c_aimThresholdDistance;
  Value<float> x250_;
  Value<float> x254_;
  Value<float> x258_aimBoxWidth;
  Value<float> x25c_aimBoxHeight;
  Value<float> x260_aimTargetTimer;
  Value<float> x264_aimAssistHorizontalAngle;
  Value<float> x268_aimAssistVerticalAngle;
  Value<float> x26c_playerHeight;
  Value<float> x270_playerXYHalfExtent;
  Value<float> x274_stepUpHeight;
  Value<float> x278_stepDownHeight;
  Value<float> x27c_playerBallHalfExtent;
  Value<float> x280_firstPersonCameraSpeed;
  Value<float> x284_;
  Value<float> x288_jumpCameraPitchDownStart;
  Value<float> x28c_jumpCameraPitchDownFull;
  Value<float> x290_jumpCameraPitchDownAngle;
  Value<float> x294_fallCameraPitchDownStart;
  Value<float> x298_fallCameraPitchDownFull;
  Value<float> x29c_fallCameraPitchDownAngle;
  Value<float> x2a0_orbitDistanceMax;
  Value<float> x2a4_grappleSwingLength;
  Value<float> x2a8_grappleSwingPeriod;
  Value<float> x2ac_grapplePullSpeedMin;
  Value<float> x2b0_grappleCameraSpeed;
  Value<float> x2b4_maxGrappleLockedTurnAlignDistance;
  Value<float> x2b8_grapplePullSpeedProportion;
  Value<float> x2bc_grapplePullSpeedMax;
  Value<float> x2c0_grappleLookCenterSpeed;
  Value<float> x2c4_maxGrappleTurnSpeed;
  Value<float> x2c8_grappleJumpForce;
  Value<float> x2cc_grappleReleaseTime;
  Value<atUint32> x2d0_grappleJumpMode;
  Value<bool> x2d4_orbitReleaseBreaksGrapple;
  Value<bool> x2d5_invertGrappleTurn;
  Value<float> x2d8_grappleBeamSpeed;
  Value<float> x2dc_grappleBeamXWaveAmplitude;
  Value<float> x2e0_grappleBeamZWaveAmplitude;
  Value<float> x2e4_grappleBeamAnglePhaseDelta;
  Value<float> x2e8_;
  Value<float> x2ec_;
  Value<float> x2f0_;
  Value<bool> x2f4_;
  Value<float> x2f8_frozenTimeout;
  Value<atUint32> x2fc_iceBreakJumpCount;
  Value<float> x300_variaDamageReduction;
  Value<float> x304_gravityDamageReduction;
  Value<float> x308_phazonDamageReduction;
};

} // namespace DataSpec::DNAMP1
